uniform vec3 uUVParameters;
attribute vec4 aPos;      //Vertex position
varying vec2 vTexCoord;   //Fragments' texture coordinate

void main()
{	
	//Deriving UVs in [0,1] x [0,1] range from default normalized device coordinates
	vTexCoord = (aPos.xy * 0.5 + vec2(0.5, 0.5));
	vTexCoord.y = 1.0 - vTexCoord.y;
	
	//Adjusting UV parameters
	// x : used to scale texture horizontally in order to keep 1:1 pixel correspondence with vertical texture dimension
	// y : used to clip off the unused bottom section of the texture
	// z : horizontal offset (for panning)
	vTexCoord = (vTexCoord )* uUVParameters.xy + vec2(uUVParameters.z, 0.0);

	gl_Position = aPos;
}